#!/usr/bin/perl
#
# AUTHOR: Leonid Mamtchenkov (leonid@leonid.maks.net)
# VERSION: 1.0
# UPDATED: Mon 17 Apr 2000 05:38:26 PM EEST
# LICENSE: GPL
# DESCRIPTION: Per user statistics on disk usage.
#

# This is a list of usernames that should be ignored.
@ignoreusers=("nobody", "squid");
@ignoredirs=("/", "/dev/null");

# Take usernames and home directories from /etc/passwd
$CurrDir = `pwd`;
open (PASSWD, "/etc/passwd");
 @inside=<PASSWD>;
close PASSWD;

$today=`date`;
print "\n";
print "  Disk usage statistics ($today)\n";
print "---\n";

FORCYCLE: for ($line=1; $line<@inside; $line++) {

 ($username, $password, $uid, $gid, $realname, $homedir, $usershell) = split(/:/,$inside[$line]);
 
 foreach (@ignoreusers) {
    if ($_ eq $username) {
	next FORCYCLE;
    }
 }

 foreach (@ignoredirs) {
    if ($_ eq $homedir) {
        PRINTLINE($username,"IGNORED",$homedir);
	next FORCYCLE;
    }
 }
     if (! -e $homedir) {
       PRINTLINE($username,"NOT FOUND",$homedir);
     } else {
       $spaceused=`cd $homedir ; du -s `;
       $spaceused=~s/\056//;
       PRINTLINE($username,$spaceused,$homedir);
       } # else
    
} # for...

print "\n";
chdir $CurrDir;

sub PRINTLINE {
    # This sub will print a with username and disk usage on the screen.
    $curruser=$_[0];   # Username
    $currdisk=$_[1];   # Disk usage
    $currhome=$_[2];   # Home directory
    
    format ScreenLine =
Username: @<<<<<<<<<< Usage: @<<<<<<<<< Home: @<<<<<<<<<<<<<<<<<<<<<<<<<<<<
          $curruser, $currdisk, $currhome
.
    
    $~ = 'ScreenLine';
    write;
    }
